/* --------------------------------------------------------------------------
 * SvgBallExample
 * --------------------------------------------------------------------------
 * prog:  Giacomo Pedemonte
 * date:  26.09.2012
 * ----------------------------------------------------------------------------
 */

BouncingBall ball1;
BouncingBall ball2;

PVector      p1 = new PVector();
PVector      p2 = new PVector();
boolean      drag = false;
boolean      drag2 = false;

void setup()
{
  size(800,600); 

  ball1 = new BouncingBall(100,100,"ball1");
  ball2 = new BouncingBall(50,50, "red-orb");
  
  // svg bild soll zentriert sein
  shapeMode(CENTER);
  smooth();
}

void draw()
{
  // hintergrund loeschen
  //background(255);
  // ghosting
  fill(255,255,255,60);
  rect(0,0,width,height);
    
  if(drag)
  { // zeichne die abschussrichtung
    p1.set(ball1._pos.x,ball1._pos.y,0);
    line(p1.x,p1.y,p2.x,p2.y);
  }
  else if(drag2)
  { // zeichne die abschussrichtung
    p1.set(ball2._pos.x,ball2._pos.y,0);
    line(p1.x,p1.y,p2.x,p2.y);
  }
  
  // zeichne den ball
  ball1.draw();
  ball2.draw();
}

void mousePressed()
{
  if(key == '1')
  {
    drag = true;
    p1.set(ball1._pos.x,ball1._pos.y,0);
  }
  else if(key == '2')
  {
    drag2 = true;
    p2.set(mouseX,mouseY,0);
  }
}

void mouseDragged()
{
  p2.set(mouseX,mouseY,0);
}

void mouseReleased()
{
  drag = false;
  drag2 = false;
  
  // abschuss staerke berechnen
  PVector dir = PVector.sub(p2,p1);
  // laenge verkuerzen
  dir.mult(.09);
  
  // der ball wird neu ausgerichtet
  if(key == '1')
  {
    ball1.set(p1,dir,.993);
  }
  else if(key == '2')
  {
    ball2.set(p1,dir,.95);
  }
}

